# Class Inet6Address

java.lang.Object
java.net.InetAddress
java.net.Inet6Address

All Implemented Interfaces:
  `Serializable`

public final class Inet6Address extends InetAddress
This class represents an Internet Protocol version 6 (IPv6) address. Defined by RFC 2373: IP Version 6 Addressing Architecture.

## Textual representation of IPv6 addresses

Textual representation of IPv6 address used as input to methods takes one of the following forms:

1. The preferred form is x:x:x:x:x:x:x:x, where the 'x's are the hexadecimal values of the eight 16-bit pieces of the address. This is the full form. For example,

   > - `1080:0:0:0:8:800:200C:417A`

   Note that it is not necessary to write the leading zeros in an individual field. However, there must be at least one numeral in every field, except as described below.

2. Due to some methods of allocating certain styles of IPv6 addresses, it will be common for addresses to contain long strings of zero bits. In order to make writing addresses containing zero bits easier, a special syntax is available to compress the zeros. The use of "::" indicates multiple groups of 16-bits of zeros. The "::" can only appear once in an address. The "::" can also be used to compress the leading and/or trailing zeros in an address. For example,

   > - `1080::8:800:200C:417A`

3. An alternative form that is sometimes more convenient when dealing with a mixed environment of IPv4 and IPv6 nodes is x:x:x:x:x:x:d.d.d.d, where the 'x's are the hexadecimal values of the six high-order 16-bit pieces of the address, and the 'd's are the decimal values of the four low-order 8-bit pieces of the standard IPv4 representation address, for example,

   > - `::FFFF:129.144.52.38`
   > - `::129.144.52.38`

   where "::FFFF:d.d.d.d" and "::d.d.d.d" are, respectively, the general forms of an IPv4-mapped IPv6 address and an IPv4-compatible IPv6 address. Note that the IPv4 portion must be in the "d.d.d.d" form. The following forms are invalid:

   > - `::FFFF:d.d.d`
   > - `::FFFF:d.d`
   > - `::d.d.d`
   > - `::d.d`

   The following form:

   > - `::FFFF:d`

   is valid, however it is an unconventional representation of the IPv4-compatible IPv6 address,

   > - `::255.255.0.d`

   while "::d" corresponds to the general IPv6 address "0:0:0:0:0:0:0:d".

For methods that return a textual representation as output value, the full form is used. Inet6Address will return the full form because it is unambiguous when used in combination with other textual data.

### Special IPv6 address

> IPv4-mapped address
>   Of the form ::ffff:w.x.y.z, this IPv6 address is used to represent an IPv4 address. It allows the native program to use the same address data structure and also the same socket when communicating with both IPv4 and IPv6 nodes.

>   In InetAddress and Inet6Address, it is used for internal representation; it has no functional role. Java will never return an IPv4-mapped address. These classes can take an IPv4-mapped address as input, both in byte array and text representation. However, it will be converted into an IPv4 address.

### Textual representation of IPv6 scoped addresses

The textual representation of IPv6 addresses as described above can be extended to specify IPv6 scoped addresses. This extension to the basic addressing architecture is described in RFC 4007: IPv6 Scoped Address Architecture.

Because link-local and site-local addresses are non-global, it is possible that different hosts may have the same destination address and may be reachable through different interfaces on the same originating system. In this case, the originating system is said to be connected to multiple zones of the same scope. In order to disambiguate which is the intended destination zone, it is possible to append a zone identifier (or scope_id) to an IPv6 address.

The general format for specifying the scope_id is the following:

> IPv6-address%scope_id

The IPv6-address is a literal IPv6 address as described above. The scope_id refers to an interface on the local system, and it can be specified in two ways.

1. As a numeric identifier. This must be a positive integer that identifies the particular interface and scope as understood by the system. Usually, the numeric values can be determined through administration tools on the system. Each interface may have multiple values, one for each scope. If the scope is unspecified, then the default value used is zero.
2. As a string. This must be the exact string that is returned by `NetworkInterface.getName()` for the particular interface in question. When an Inet6Address is created in this way, the numeric scope-id is determined at the time the object is created by querying the relevant NetworkInterface.

Note also, that the numeric scope_id can be retrieved from Inet6Address instances returned from the NetworkInterface class. This can be used to find out the current scope ids configured on the system.

### Textual representation of IPv6 addresses as method inputs

Methods of `InetAddress` and `Inet6Address` that accept a textual representation of an IPv6 address allow for that representation to be enclosed in square brackets. For example,

     // The full IPv6 form
     InetAddress.getByName("1080:0:0:0:8:800:200C:417A");   // ==> /1080:0:0:0:8:800:200c:417a
     InetAddress.getByName("[1080:0:0:0:8:800:200C:417A]"); // ==> /1080:0:0:0:8:800:200c:417a

     // IPv6 scoped address with scope-id as string
     Inet6Address.ofLiteral("fe80::1%en0");   // ==> /fe80:0:0:0:0:0:0:1%en0
     Inet6Address.ofLiteral("[fe80::1%en0]"); // ==> /fe80:0:0:0:0:0:0:1%en0

Since:
  1.4
External Specifications
  - RFC 2373: IP Version 6 Addressing Architecture
  - RFC 4007: IPv6 Scoped Address Architecture
See Also:
  - Serialized Form

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Compares this object against the specified object.
`byte[]`
`getAddress()`
Returns the raw IP address of this `InetAddress` object.
`static Inet6Address`
`getByAddress(String host, byte[] addr, int scope_id)`
Create an Inet6Address in the exact manner of `InetAddress.getByAddress(String,byte[])` except that the IPv6 scope_id is set to the given numeric value.
`static Inet6Address`
`getByAddress(String host, byte[] addr, NetworkInterface nif)`
Create an Inet6Address in the exact manner of `InetAddress.getByAddress(String,byte[])` except that the IPv6 scope_id is set to the value corresponding to the given interface for the address type specified in `addr`.
`String`
`getHostAddress()`
Returns the IP address string in textual presentation.
`NetworkInterface`
`getScopedInterface()`
Returns the scoped interface, if this instance was created with a scoped interface.
`int`
`getScopeId()`
Returns the numeric scopeId, if this instance is associated with an interface.
`int`
`hashCode()`
Returns a hashcode for this IP address.
`boolean`
`isAnyLocalAddress()`
Utility routine to check if the InetAddress is a wildcard address.
`boolean`
`isIPv4CompatibleAddress()`
Utility routine to check if the InetAddress is an IPv4 compatible IPv6 address.
`boolean`
`isLinkLocalAddress()`
Utility routine to check if the InetAddress is a link local address.
`boolean`
`isLoopbackAddress()`
Utility routine to check if the InetAddress is a loopback address.
`boolean`
`isMCGlobal()`
Utility routine to check if the multicast address has global scope.
`boolean`
`isMCLinkLocal()`
Utility routine to check if the multicast address has link scope.
`boolean`
`isMCNodeLocal()`
Utility routine to check if the multicast address has node scope.
`boolean`
`isMCOrgLocal()`
Utility routine to check if the multicast address has organization scope.
`boolean`
`isMCSiteLocal()`
Utility routine to check if the multicast address has site scope.
`boolean`
`isMulticastAddress()`
Utility routine to check if the InetAddress is an IP multicast address. 11111111 at the start of the address identifies the address as being a multicast address.
`boolean`
`isSiteLocalAddress()`
Utility routine to check if the InetAddress is a site local address.
`static InetAddress`
`ofLiteral(String ipv6AddressLiteral)`
Creates an `InetAddress` based on the provided textual representation of an IPv6 address.

### Methods declared in class InetAddress

`getAllByName, getByAddress, getByAddress, getByName, getCanonicalHostName, getHostName, getLocalHost, getLoopbackAddress, isReachable, isReachable, toString`
Modifier and Type
Method
Description
`static InetAddress[]`
`getAllByName(String host)`
Given the name of a host, returns an array of its IP addresses, based on the system-wide resolver.
`static InetAddress`
`getByAddress(byte[] addr)`
Returns an `InetAddress` object given the raw IP address .
`static InetAddress`
`getByAddress(String host, byte[] addr)`
Creates an InetAddress based on the provided host name and IP address.
`static InetAddress`
`getByName(String host)`
Determines the IP address of a host, given the host's name.
`String`
`getCanonicalHostName()`
Gets the fully qualified domain name for this IP address using the system-wide resolver.
`String`
`getHostName()`
Gets the host name for this IP address.
`static InetAddress`
`getLocalHost()`
Returns the address of the local host.
`static InetAddress`
`getLoopbackAddress()`
Returns the loopback address.
`boolean`
`isReachable(int timeout)`
Test whether that address is reachable.
`boolean`
`isReachable(NetworkInterface netif, int ttl, int timeout)`
Test whether that address is reachable.
`String`
`toString()`
Converts this IP address to a `String`.

### Methods declared in class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Method Details

### getByAddress

public static Inet6Address getByAddress(String host, byte[] addr, NetworkInterface nif) throws UnknownHostException
Create an Inet6Address in the exact manner of `InetAddress.getByAddress(String,byte[])` except that the IPv6 scope_id is set to the value corresponding to the given interface for the address type specified in `addr`. The call will fail with an UnknownHostException if the given interface does not have a numeric scope_id assigned for the given address type (e.g. link-local or site-local). See here for a description of IPv6 scoped addresses.

Parameters:
  `host` - the specified host
  `addr` - the raw IP address in network byte order
  `nif` - an interface this address must be associated with.
Returns:
  an Inet6Address object created from the raw IP address.
Throws:
  `UnknownHostException` - if IP address is of illegal length, or if the interface does not have a numeric scope_id assigned for the given address type.
Since:
  1.5

### getByAddress

public static Inet6Address getByAddress(String host, byte[] addr, int scope_id) throws UnknownHostException
Create an Inet6Address in the exact manner of `InetAddress.getByAddress(String,byte[])` except that the IPv6 scope_id is set to the given numeric value. The scope_id is not checked to determine if it corresponds to any interface on the system. See here for a description of IPv6 scoped addresses.

Parameters:
  `host` - the specified host
  `addr` - the raw IP address in network byte order
  `scope_id` - the numeric scope_id for the address.
Returns:
  an Inet6Address object created from the raw IP address.
Throws:
  `UnknownHostException` - if IP address is of illegal length.
Since:
  1.5

### ofLiteral

public static InetAddress ofLiteral(String ipv6AddressLiteral)
Creates an `InetAddress` based on the provided textual representation of an IPv6 address.

If the provided address literal cannot represent a valid IPv6 address an `IllegalArgumentException` is thrown. An `IllegalArgumentException` is also thrown if an IPv6 scoped address literal contains a scope-id that doesn't map to any network interface on the system, or if a scope-id is present in an IPv4-mapped IPv6 address literal.

This method doesn't block, i.e. no reverse lookup is performed.

Note that IPv6 address literal forms are also supported when enclosed in square brackets. Note also that if the supplied literal represents an IPv4-mapped IPv6 address an instance of `Inet4Address` is returned.

Parameters:
  `ipv6AddressLiteral` - the textual representation of an IPv6 address.
Returns:
  an `InetAddress` object with no hostname set, and constructed from the provided IPv6 address literal.
Throws:
  `IllegalArgumentException` - if the `ipv6AddressLiteral` cannot be parsed as an IPv6 address literal.
  `NullPointerException` - if the `ipv6AddressLiteral` is `null`.
Since:
  22

### isMulticastAddress

public boolean isMulticastAddress()
Utility routine to check if the InetAddress is an IP multicast address. 11111111 at the start of the address identifies the address as being a multicast address.

Overrides:
  `isMulticastAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is an IP multicast address

### isAnyLocalAddress

public boolean isAnyLocalAddress()
Utility routine to check if the InetAddress is a wildcard address.

Overrides:
  `isAnyLocalAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is a wildcard address.

### isLoopbackAddress

public boolean isLoopbackAddress()
Utility routine to check if the InetAddress is a loopback address.

Overrides:
  `isLoopbackAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is a loopback address; or false otherwise.

### isLinkLocalAddress

public boolean isLinkLocalAddress()
Utility routine to check if the InetAddress is a link local address.

Overrides:
  `isLinkLocalAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is a link local address; or false if address is not a link local unicast address.

### isSiteLocalAddress

public boolean isSiteLocalAddress()
Utility routine to check if the InetAddress is a site local address.

Overrides:
  `isSiteLocalAddress` in class `InetAddress`
Returns:
  a `boolean` indicating if the InetAddress is a site local address; or false if address is not a site local unicast address.

### isMCGlobal

public boolean isMCGlobal()
Utility routine to check if the multicast address has global scope.

Overrides:
  `isMCGlobal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of global scope, false if it is not of global scope or it is not a multicast address

### isMCNodeLocal

public boolean isMCNodeLocal()
Utility routine to check if the multicast address has node scope.

Overrides:
  `isMCNodeLocal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of node-local scope, false if it is not of node-local scope or it is not a multicast address

### isMCLinkLocal

public boolean isMCLinkLocal()
Utility routine to check if the multicast address has link scope.

Overrides:
  `isMCLinkLocal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of link-local scope, false if it is not of link-local scope or it is not a multicast address

### isMCSiteLocal

public boolean isMCSiteLocal()
Utility routine to check if the multicast address has site scope.

Overrides:
  `isMCSiteLocal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of site-local scope, false if it is not of site-local scope or it is not a multicast address

### isMCOrgLocal

public boolean isMCOrgLocal()
Utility routine to check if the multicast address has organization scope.

Overrides:
  `isMCOrgLocal` in class `InetAddress`
Returns:
  a `boolean` indicating if the address has is a multicast address of organization-local scope, false if it is not of organization-local scope or it is not a multicast address

### getAddress

public byte[] getAddress()
Returns the raw IP address of this `InetAddress` object. The result is in network byte order: the highest order byte of the address is in `getAddress()[0]`.

Overrides:
  `getAddress` in class `InetAddress`
Returns:
  the raw IP address of this object.

### getScopeId

public int getScopeId()
Returns the numeric scopeId, if this instance is associated with an interface. If no scoped_id is set, the returned value is zero.

Returns:
  the scopeId, or zero if not set.
Since:
  1.5

### getScopedInterface

public NetworkInterface getScopedInterface()
Returns the scoped interface, if this instance was created with a scoped interface.

Returns:
  the scoped interface, or null if not set.
Since:
  1.5

### getHostAddress

public String getHostAddress()
Returns the IP address string in textual presentation. If the instance was created specifying a scope identifier then the scope id is appended to the IP address preceded by a "%" (per-cent) character. This can be either a numeric value or a string, depending on which was used to create the instance.

Overrides:
  `getHostAddress` in class `InetAddress`
Returns:
  the raw IP address in a string format.

### hashCode

public int hashCode()
Returns a hashcode for this IP address.

Overrides:
  `hashCode` in class `InetAddress`
Returns:
  a hash code value for this IP address.
See Also:
  - `Object.equals(java.lang.Object)`
  - `System.identityHashCode(Object)`

### equals

public boolean equals(Object obj)
Compares this object against the specified object. The result is `true` if and only if the argument is not `null` and it represents the same IP address as this object.

Two instances of `InetAddress` represent the same IP address if the length of the byte arrays returned by `getAddress` is the same for both, and each of the array components is the same for the byte arrays.

Overrides:
  `equals` in class `InetAddress`
Parameters:
  `obj` - the object to compare against.
Returns:
  `true` if the objects are the same; `false` otherwise.
See Also:
  - `InetAddress.getAddress()`

### isIPv4CompatibleAddress

public boolean isIPv4CompatibleAddress()
Utility routine to check if the InetAddress is an IPv4 compatible IPv6 address.

Returns:
  a `boolean` indicating if the InetAddress is an IPv4 compatible IPv6 address; or false if address is IPv4 address.